// A01-Servos90
// set servos to mid position = 90 degrees so servo horns can be fitted in the correct orientation
// Binary sketch size: 2,672 bytes (of a 14,336 byte maximum)

#include <Servo.h>
/* Servo servoname - create servo object to control servo servoname  
   attach(pin) - Attaches a servo to an i/o pin.
   attach(pin,min,max) - Attaches to a pin setting min and max values in microseconds, default min is 544, max is 2400  
   write()     - Sets the servo angle in degrees.  (invalid angle that is valid as pulse in microseconds is treated as microseconds)
   writeMicroseconds() - Sets the servo pulse width in microseconds 
   read()      - Gets the last written servo pulse width as an angle between 0 and 180. 
   readMicroseconds()  - Gets the last written servo pulse width in microseconds. (was read_us() in first release)
   attached()  - Returns true if there is a servo attached. 
   detach()    - Stops an attached i/o pin from pulsing its servo. 
 */ 
#include <EEPROM.h>     // to read and write internal EEPROM
                        // EEPROM.write(address,bytevalue)
			// bytevalue =EEPROM.read(address)
//----------------------------------------------------------- 
//EEPROM addresses
//const byte Ef_walking =0;
const byte ErollC =1;
const byte EpaceC =2;
//-----------------------------------------------------------                                
Servo servoR;  // create servo object to control Roll servo 
Servo servoP;  // create servo object to control Pace servo 
//----------------------------------------------------------- 
//edit this to your setup
const byte servoRpin =7;      //Roll servo on pin 7   
const byte servoPpin =8;      //Pace servo on pin 8   
//-----------------------------------------------------------                                
byte rollC =90;  // roll centre = 90 => upright
byte paceC =90;  // pace centre = 90 => feet together
//===========================================================
void setup() 
{ 
  EEPROM.write(ErollC,rollC);    // initialise EEPROM ErollC
  EEPROM.write(EpaceC,paceC);    // initialise EEPROM EpaceC
  servoR.attach(servoRpin);   // attaches servoRpin to the servo Robject 
  servoP.attach(servoPpin);   // attaches servoPpin to the servo Pobject 
} 
//-----------------------------------------------------------   
void loop()
{ 
    servoR.write(rollC);              // tell servo to go to position rollC
    servoP.write(paceC);              // tell servo to go to position paceC
    delay(1000);                   // waits 1000ms
} 
//===========================================================

