// A03-walkFd
//  very simple routinewalk to walk two steps and repeat,
//  added f_walking
//    so robot can be stopped by pressing RESET 
//    then restarted by pressing RESET
// Binary sketch size: 3,180 bytes (of a 14,336 byte maximum)

//----------------------------------------------------------- 
// edit to select defaults for robot type                                               // *new

/* Bambino
  const byte Drollmin  =60;
  const byte DrollC    =90;
  const byte Drollmax  =120;
  const byte Dpacemin  =75;
  const byte DpaceC    =90;
  const byte Dpacemax  =105;
  const byte Drollby   =10;
  const byte Dpaceby   =10;
  const byte servoRpin =7;      //Roll servo on pin 7   
  const byte servoPpin =8;      //Pace servo on pin 8   
*/  
// Jet
  const byte Drollmin  =60;
  const byte DrollC    =90;
  const byte Drollmax  =120;
  const byte Dpacemin  =75;
  const byte DpaceC    =90;
  const byte Dpacemax  =105;
  const byte Drollby   =25;
  const byte Dpaceby   =40;   
  const byte servoRpin =7;      //Roll servo on pin 7   
  const byte servoPpin =8;      //Pace servo on pin 8   
//  
//----------------------------------------------------------- 
#include <Servo.h>
/* Servo servoname - create servo object to control servo servoname  
   attach(pin) - Attaches a servo to an i/o pin.
   attach(pin,min,max) - Attaches to a pin setting min and max values in microseconds, default min is 544, max is 2400  
   write()     - Sets the servo angle in degrees.  (invalid angle that is valid as pulse in microseconds is treated as microseconds)
   writeMicroseconds() - Sets the servo pulse width in microseconds 
   read()      - Gets the last written servo pulse width as an angle between 0 and 180. 
   readMicroseconds()  - Gets the last written servo pulse width in microseconds. (was read_us() in first release)
   attached()  - Returns true if there is a servo attached. 
   detach()    - Stops an attached i/o pin from pulsing its servo. 
 */ 
#include <EEPROM.h>     // to read and write internal EEPROM
                        // EEPROM.write(address,bytevalue)
			// bytevalue =EEPROM.read(address)
//----------------------------------------------------------- 
//EEPROM addresses
const byte Ef_walking =0;  // EEPROM address for f_walking boolean flag                             *new
const byte Erollmin =1;
const byte ErollC   =2;
const byte Erollmax =3;
const byte Epacemin =4;
const byte EpaceC   =5;
const byte Epacemax =6;
const byte Eroll    =7;
const byte Epace    =8;

//-----------------------------------------------------------                               
Servo servoR;    // create servo object to control Roll servo 
Servo servoP;    // create servo object to control Pace servo 
//===========================================================                                
byte sframe =20; // Servo frame rate, same as Servo.h frame rate, no point in it being less        *new
byte rollC   =EEPROM.read(ErollC);                              //*new
byte paceC   =EEPROM.read(EpaceC);                              //*new
byte rollmin =EEPROM.read(Erollmin);                            //*new
byte rollmax =EEPROM.read(Erollmax);                            //*new
byte pacemin =EEPROM.read(Epacemin);                            //*new
byte pacemax =EEPROM.read(Epacemax);                            //*new
byte rollby  =EEPROM.read(Eroll);   // default roll about rollC                             *new
byte paceby  =EEPROM.read(Epace);   // default pace about paceC                             *new
byte rollat;     // variable to store the roll servo position                               *new
byte paceat;     // variable to store the pace servo position                               *new
//byte rollto;   // variable to store the roll servo position                               *new
//byte paceto;   // variable to store the pace servo position                               *new
boolean  f_walking =true; // walk/stop                                                      *new
//byte cmnd ;    // current command
//===========================================================
void setup() 				// *changed
{ 
  f_walking =EEPROM.read(Ef_walking) ;           // read old state 
  f_walking =!f_walking ;			 // !true ->false, !false ->true
  EEPROM.write(Ef_walking,f_walking) ;           // save new state
  if (f_walking)  
    {  
    if (rollC==255)   {rollC =DrollC;}      // in case it is not initialised
    if (rollmin==255) {rollmin =Drollmin;}  // in case it is not initialised
    if (rollmax==255) {rollmax =Drollmax;}  // in case it is not initialised
    if (paceC==255)   {paceC =DpaceC;}      // in case it is not initialised
    if (pacemin==255) {pacemin =Dpacemin;}  // in case it is not initialised
    if (pacemax==255) {pacemax =Dpacemax;}  // in case it is not initialised
    if (rollby==255)  {rollby =Drollby;}    // in case it is not initialised
    if (paceby==255)  {paceby =Dpaceby;}    // in case it is not initialised
   
    servoR.write(rollC);           // tell servo to go to position rollC 
    servoP.write(paceC);           // tell servo to go to position paceC
    rollat =rollC;
    paceat =paceC;
    servoR.attach(servoRpin);      // attaches servoRpin to the servoR object 
    servoP.attach(servoPpin);      // attaches servoPpin to the servoP object 
    }	
  //Serial.begin(9600);
} 
//-----------------------------------------------------------   
void loop()          // walk two steps and repeat                                             *new
{
 // roll one way 
  for (rollat =rollat ; rollat <= rollC +rollby; rollat += 1)  	// in steps of 1 degree 
  { servoR.write(rollat);             // tell servo to go to position rollat
    delay(sframe); }                  // wait sframe
   
  // step
  for (paceat =paceat ; paceat <= paceC +paceby; paceat += 1)    // in steps of 1 degree 
  { servoP.write(paceat);             // tell servo to go to position paceat
    delay(sframe); }                  // wait sframe
   
  // roll other way 
  for (rollat =rollat ; rollat >= rollC -rollby; rollat -= 1)    // in steps of 1 degree 
  { servoR.write(rollat);             // tell servo to go to position rollat
    delay(sframe); }                  // wait sframe
   
  // step
  for (paceat =paceat ; paceat >= paceC -paceby; paceat -= 1)    // in steps of 1 degree 
  { servoP.write(paceat);             // tell servo to go to position paceat
    delay(sframe); }                  // wait sframe 
 } 
//===========================================================

